/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/
namespace IRDB_SDK
{
	class BaseObj_t
	{
		protected:
			BaseObj_t() {}
			BaseObj_t(const BaseObj_t& copy) = delete;

		public:
			virtual ~BaseObj_t() {}

			virtual DatabaseID_t           getBaseID()      const = 0;
			virtual DatabaseID_t           getDoipID()      const = 0;
			virtual const RelocationSet_t& getRelocations() const = 0;

			virtual void setRelocations(const RelocationSet_t& rels) = 0;
			virtual void setDoipID(Doip_t *p_dp)      = 0;
			virtual void setBaseID(DatabaseID_t p_id) = 0;

			const static int NOT_IN_DATABASE;
		        static void setInterface(DBinterface_t *dbintr);

	};

}
