/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{

	using namespace std;

	class File_t : virtual public BaseObj_t
	{
		protected:
			File_t() { };
			File_t(const File_t& copy) = delete;
		public:
			virtual ~File_t() { };

			virtual string       getAddressTableName()     const = 0;
			virtual string       getFunctionTableName()    const = 0;
			virtual string       getInstructionTableName() const = 0;
			virtual string       getICFSTableName()        const = 0;
			virtual string       getICFSMapTableName()     const = 0;
			virtual string       getRelocationsTableName() const = 0;
			virtual string       getTypesTableName()       const = 0;
			virtual string       getScoopTableName()       const = 0;
			virtual string       getEhProgramTableName()   const = 0;
			virtual string       getEhCallSiteTableName()  const = 0;
			virtual string       getURL()                  const = 0;
			virtual int          getELFOID()               const = 0;
			virtual DatabaseID_t getFileID()               const = 0;

	};

}
