/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

#include <irdb-core>
#include <irdb-transform>
#include <string>
#include <memory>


namespace IRDB_SDK
{

using namespace std;

class ElfDependencies_t 
{
	protected:
		ElfDependencies_t() { } 
		ElfDependencies_t(const ElfDependencies_t& copy) = delete;
	public:
		virtual ~ElfDependencies_t() { } 

		virtual void prependLibraryDepedencies(const string& libName) = 0; 
		virtual void appendLibraryDepedencies(const string& libName)  = 0; 

		// return scoop and offset
		virtual pair<IRDB_SDK::DataScoop_t*,int> appendGotEntry(const string &symbolName)   = 0 ;

		// return instruction that's the plt entry.
		virtual Instruction_t* appendPltEntry(const string &symbolName)   = 0 ;

		static unique_ptr<ElfDependencies_t> factory(IRDB_SDK::FileIR_t* firp);

};


}
