/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{

	class IBTProvenance_t
	{

		public:
			IBTProvenance_t() {}
			IBTProvenance_t(const IBTProvenance_t& copy) = delete;
		public:

			virtual ~IBTProvenance_t() {} 	

			static unique_ptr<IBTProvenance_t> factory(const FileIR_t* f=NULL); 

			virtual const Provenance_t& getProvenance(const Instruction_t* i)  const = 0 ;
			virtual const Provenance_t& operator[] (const Instruction_t* i)    const = 0 ;
	 

	};

}

